using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace csScriptor
{
  public partial class MainForm : Form
  {
    const uint SCARD_S_SUCCESS = 0x00000000;
    const uint SCARD_F_INTERNAL_ERROR = 0x80100001;
    const uint SCARD_E_CANCELLED = 0x80100002;
    const uint SCARD_E_INVALID_HANDLE = 0x80100003;
    const uint SCARD_E_INVALID_PARAMETER = 0x80100004;
    const uint SCARD_E_INVALID_TARGET = 0x80100005;
    const uint SCARD_E_NO_MEMORY = 0x80100006;
    const uint SCARD_F_WAITED_TOO_LONG = 0x80100007;
    const uint SCARD_E_INSUFFICIENT_BUFFER = 0x80100008;
    const uint SCARD_E_UNKNOWN_READER = 0x80100009;
    const uint SCARD_E_TIMEOUT = 0x8010000A;
    const uint SCARD_E_SHARING_VIOLATION = 0x8010000B;
    const uint SCARD_E_NO_SMARTCARD = 0x8010000C;
    const uint SCARD_E_UNKNOWN_CARD = 0x8010000D;
    const uint SCARD_E_CANT_DISPOSE = 0x8010000E;
    const uint SCARD_E_PROTO_MISMATCH = 0x8010000F;
    const uint SCARD_E_NOT_READY = 0x80100010;
    const uint SCARD_E_INVALID_VALUE = 0x80100011;
    const uint SCARD_E_SYSTEM_CANCELLED = 0x80100012;
    const uint SCARD_F_COMM_ERROR = 0x80100013;
    const uint SCARD_F_UNKNOWN_ERROR = 0x80100014;
    const uint SCARD_E_INVALID_ATR = 0x80100015;
    const uint SCARD_E_NOT_TRANSACTED = 0x80100016;
    const uint SCARD_E_READER_UNAVAILABLE = 0x80100017;
    const uint SCARD_P_SHUTDOWN = 0x80100018;
    const uint SCARD_E_PCI_TOO_SMALL = 0x80100019;
    const uint SCARD_E_READER_UNSUPPORTED = 0x8010001A;
    const uint SCARD_E_DUPLICATE_READER = 0x8010001B;
    const uint SCARD_E_CARD_UNSUPPORTED = 0x8010001C;
    const uint SCARD_E_NO_SERVICE = 0x8010001D;
    const uint SCARD_E_SERVICE_STOPPED = 0x8010001E;
    const uint SCARD_E_UNEXPECTED = 0x8010001F;
    const uint SCARD_E_ICC_INSTALLATION = 0x80100020;
    const uint SCARD_E_ICC_CREATEORDER = 0x80100021;
    const uint SCARD_E_UNSUPPORTED_FEATURE = 0x80100022;
    const uint SCARD_E_DIR_NOT_FOUND = 0x80100023;
    const uint SCARD_E_FILE_NOT_FOUND = 0x80100024;
    const uint SCARD_E_NO_DIR = 0x80100025;
    const uint SCARD_E_NO_FILE = 0x80100026;
    const uint SCARD_E_NO_ACCESS = 0x80100027;
    const uint SCARD_E_WRITE_TOO_MANY = 0x80100028;
    const uint SCARD_E_BAD_SEEK = 0x80100029;
    const uint SCARD_E_INVALID_CHV = 0x8010002A;
    const uint SCARD_E_UNKNOWN_RES_MNG = 0x8010002B;
    const uint SCARD_E_NO_SUCH_CERTIFICATE = 0x8010002C;
    const uint SCARD_E_CERTIFICATE_UNAVAILABLE = 0x8010002D;
    const uint SCARD_E_NO_READERS_AVAILABLE = 0x8010002E;
    const uint SCARD_E_COMM_DATA_LOST = 0x8010002F;
    const uint SCARD_E_NO_KEY_CONTAINER = 0x80100030;
    const uint SCARD_W_UNSUPPORTED_CARD = 0x80100065;
    const uint SCARD_W_UNRESPONSIVE_CARD = 0x80100066;
    const uint SCARD_W_UNPOWERED_CARD = 0x80100067;
    const uint SCARD_W_RESET_CARD = 0x80100068;
    const uint SCARD_W_REMOVED_CARD = 0x80100069;
    const uint SCARD_W_SECURITY_VIOLATION = 0x8010006A;
    const uint SCARD_W_WRONG_CHV = 0x8010006B;
    const uint SCARD_W_CHV_BLOCKED = 0x8010006C;
    const uint SCARD_W_EOF = 0x8010006D;
    const uint SCARD_W_CANCELLED_BY_USER = 0x8010006E;
    const uint SCARD_W_CARD_NOT_AUTHENTICATED = 0x8010006F;
    const uint SCARD_STATE_UNAWARE = 0x0000;
    const uint SCARD_STATE_IGNORE = 0x0001;
    const uint SCARD_STATE_CHANGED = 0x0002;
    const uint SCARD_STATE_UNKNOWN = 0x0004;
    const uint SCARD_STATE_UNAVAILABLE = 0x0008;
    const uint SCARD_STATE_EMPTY = 0x0010;
    const uint SCARD_STATE_PRESENT = 0x0020;
    const uint SCARD_STATE_ATRMATCH = 0x0040;
    const uint SCARD_STATE_EXCLUSIVE = 0x0080;
    const uint SCARD_STATE_INUSE = 0x0100;
    const uint SCARD_STATE_MUTE = 0x0200;


    public string codeToStr(uint code)
    {
      switch (code)
      {
        case SCARD_S_SUCCESS: return "SCARD_S_SUCCESS";
        case SCARD_F_INTERNAL_ERROR: return "SCARD_F_INTERNAL_ERROR";
        case SCARD_E_CANCELLED: return "SCARD_E_CANCELLED";
        case SCARD_E_INVALID_HANDLE: return "SCARD_E_INVALID_HANDLE";
        case SCARD_E_INVALID_PARAMETER: return "SCARD_E_INVALID_PARAMETER";
        case SCARD_E_INVALID_TARGET: return "SCARD_E_INVALID_TARGET";
        case SCARD_E_NO_MEMORY: return "SCARD_E_NO_MEMORY";
        case SCARD_F_WAITED_TOO_LONG: return "SCARD_F_WAITED_TOO_LONG";
        case SCARD_E_INSUFFICIENT_BUFFER: return "SCARD_E_INSUFFICIENT_BUFFER";
        case SCARD_E_UNKNOWN_READER: return "SCARD_E_UNKNOWN_READER";
        case SCARD_E_TIMEOUT: return "SCARD_E_TIMEOUT";
        case SCARD_E_SHARING_VIOLATION: return "SCARD_E_SHARING_VIOLATION";
        case SCARD_E_NO_SMARTCARD: return "SCARD_E_NO_SMARTCARD";
        case SCARD_E_UNKNOWN_CARD: return "SCARD_E_UNKNOWN_CARD";
        case SCARD_E_CANT_DISPOSE: return "SCARD_E_CANT_DISPOSE";
        case SCARD_E_PROTO_MISMATCH: return "SCARD_E_PROTO_MISMATCH";
        case SCARD_E_NOT_READY: return "SCARD_E_NOT_READY";
        case SCARD_E_INVALID_VALUE: return "SCARD_E_INVALID_VALUE";
        case SCARD_E_SYSTEM_CANCELLED: return "SCARD_E_SYSTEM_CANCELLED";
        case SCARD_F_COMM_ERROR: return "SCARD_F_COMM_ERROR";
        case SCARD_F_UNKNOWN_ERROR: return "SCARD_F_UNKNOWN_ERROR";
        case SCARD_E_INVALID_ATR: return "SCARD_E_INVALID_ATR";
        case SCARD_E_NOT_TRANSACTED: return "SCARD_E_NOT_TRANSACTED";
        case SCARD_E_READER_UNAVAILABLE: return "SCARD_E_READER_UNAVAILABLE";
        case SCARD_P_SHUTDOWN: return "SCARD_P_SHUTDOWN";
        case SCARD_E_PCI_TOO_SMALL: return "SCARD_E_PCI_TOO_SMALL";
        case SCARD_E_READER_UNSUPPORTED: return "SCARD_E_READER_UNSUPPORTED";
        case SCARD_E_DUPLICATE_READER: return "SCARD_E_DUPLICATE_READER";
        case SCARD_E_CARD_UNSUPPORTED: return "SCARD_E_CARD_UNSUPPORTED";
        case SCARD_E_NO_SERVICE: return "SCARD_E_NO_SERVICE";
        case SCARD_E_SERVICE_STOPPED: return "SCARD_E_SERVICE_STOPPED";
        case SCARD_E_UNEXPECTED: return "SCARD_E_UNEXPECTED";
        case SCARD_E_ICC_INSTALLATION: return "SCARD_E_ICC_INSTALLATION";
        case SCARD_E_ICC_CREATEORDER: return "SCARD_E_ICC_CREATEORDER";
        case SCARD_E_UNSUPPORTED_FEATURE: return "SCARD_E_UNSUPPORTED_FEATURE";
        case SCARD_E_DIR_NOT_FOUND: return "SCARD_E_DIR_NOT_FOUND";
        case SCARD_E_FILE_NOT_FOUND: return "SCARD_E_FILE_NOT_FOUND";
        case SCARD_E_NO_DIR: return "SCARD_E_NO_DIR";
        case SCARD_E_NO_FILE: return "SCARD_E_NO_FILE";
        case SCARD_E_NO_ACCESS: return "SCARD_E_NO_ACCESS";
        case SCARD_E_WRITE_TOO_MANY: return "SCARD_E_WRITE_TOO_MANY";
        case SCARD_E_BAD_SEEK: return "SCARD_E_BAD_SEEK";
        case SCARD_E_INVALID_CHV: return "SCARD_E_INVALID_CHV";
        case SCARD_E_UNKNOWN_RES_MNG: return "SCARD_E_UNKNOWN_RES_MNG";
        case SCARD_E_NO_SUCH_CERTIFICATE: return "SCARD_E_NO_SUCH_CERTIFICATE";
        case SCARD_E_CERTIFICATE_UNAVAILABLE: return "SCARD_E_CERTIFICATE_UNAVAILABLE";
        case SCARD_E_NO_READERS_AVAILABLE: return "SCARD_E_NO_READERS_AVAILABLE";
        case SCARD_E_COMM_DATA_LOST: return "SCARD_E_COMM_DATA_LOST";
        case SCARD_E_NO_KEY_CONTAINER: return "SCARD_E_NO_KEY_CONTAINER";
        //case SCARD_E_SERVER_TOO_BUSY : return "SCARD_E_SERVER_TOO_BUSY";
        case SCARD_W_UNSUPPORTED_CARD: return "SCARD_W_UNSUPPORTED_CARD";
        case SCARD_W_UNRESPONSIVE_CARD: return "SCARD_W_UNRESPONSIVE_CARD";
        case SCARD_W_UNPOWERED_CARD: return "SCARD_W_UNPOWERED_CARD";
        case SCARD_W_RESET_CARD: return "SCARD_W_RESET_CARD";
        case SCARD_W_REMOVED_CARD: return "SCARD_W_REMOVED_CARD";
        case SCARD_W_SECURITY_VIOLATION: return "SCARD_W_SECURITY_VIOLATION";
        case SCARD_W_WRONG_CHV: return "SCARD_W_WRONG_CHV";
        case SCARD_W_CHV_BLOCKED: return "SCARD_W_CHV_BLOCKED";
        case SCARD_W_EOF: return "SCARD_W_EOF";
        case SCARD_W_CANCELLED_BY_USER: return "SCARD_W_CANCELLED_BY_USER";
        case SCARD_W_CARD_NOT_AUTHENTICATED: return "SCARD_W_CARD_NOT_AUTHENTICATED";
        default: return "";
      }
    }

    public string StateToStr(uint State)
    {
      uint empty = State & SCARD_STATE_EMPTY;
      uint unaware = State & SCARD_STATE_UNAWARE;
      uint ignore = State & SCARD_STATE_IGNORE;
      uint changed = State & SCARD_STATE_CHANGED;
      uint unknown = State & SCARD_STATE_UNKNOWN;
      uint unavailable = State & SCARD_STATE_UNAVAILABLE;
      uint present = State & SCARD_STATE_PRESENT;
      uint atrMatch = State & SCARD_STATE_ATRMATCH;
      uint exclusive = State & SCARD_STATE_EXCLUSIVE;
      uint inuse = State & SCARD_STATE_INUSE;
      uint mute = State & SCARD_STATE_MUTE;

      if (mute != 0) 
        return "SCARD_STATE_MUTE:"
          + " Mute card in the reader. Try again";
      if (inuse != 0)
        return "SCARD_STATE_INUSE :"
          +" There is a card in a reader, avalaible for use";
      if (exclusive != 0)
        return "SCARD_STATE_EXCLUSIVE :"
          +" The card inserted is already in use in Exclusive mode";
      if (atrMatch !=0)
        return "SCARD_STATE_ATRMATCH : inserted card's ATR matches";
      if (present !=0)
        return "SCARD_STATE_PRESENT :"
          +" Card present. Connect or Reconnect before use ";
      if (empty !=0)
        return "SCARD_STATE_EMPTY : Card removed";
      if (unavailable !=0)
        return "SCARD_STATE_UNAVAILABLE : Status unavailable";
      if (unknown != 0)
        return "SCARD_STATE_UNKNOWN : Reader unknown";
      if (changed != 0)
        return "SCARD_STATE_CHANGED : State has changed";
      if (ignore != 0)
        return "SCARD_STATE_IGNORE : Reader ignored";
      if (unaware != 0)
        return "SCARD_STATE_UNAWARE : Status wanted";
      return "Unknown state code ";
    }
   
  }
}